/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.sing.point.wrapper;

import org.springblade.common.utils.SpringContextHolder;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.ObjectUtil;
import org.springblade.sing.active.entity.ActiveProductRecord;
import org.springblade.sing.active.entity.ActiveRecord;
import org.springblade.sing.active.service.IActiveProductRecordService;
import org.springblade.sing.active.service.IActiveRecordService;
import org.springblade.sing.goods.entity.HelpGoods;
import org.springblade.sing.goods.service.IHelpGoodsService;
import org.springblade.sing.point.entity.CmccPointRecord;
import org.springblade.sing.point.vo.CmccPointRecordVO;
import org.springblade.sing.user.entity.LoginUser;
import org.springblade.sing.user.service.ILoginUserService;

import java.util.Objects;

/**
 * 移动积分兑换道具记录表包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-11-11
 */
public class CmccPointRecordWrapper extends BaseEntityWrapper<CmccPointRecord, CmccPointRecordVO>  {

	private static final IHelpGoodsService helpGoodsService = SpringContextHolder.getBean(IHelpGoodsService.class);
	private static final ILoginUserService loginUserService = SpringContextHolder.getBean(ILoginUserService.class);
	private static final IActiveRecordService activeRecordService = SpringContextHolder.getBean(IActiveRecordService.class);
	private static final IActiveProductRecordService activeProductRecordService = SpringContextHolder.getBean(IActiveProductRecordService.class);

	public static CmccPointRecordWrapper build() {
		return new CmccPointRecordWrapper();
 	}

	@Override
	public CmccPointRecordVO entityVO(CmccPointRecord cmccPointRecord) {
		CmccPointRecordVO cmccPointRecordVO = Objects.requireNonNull(BeanUtil.copy(cmccPointRecord, CmccPointRecordVO.class));

		HelpGoods helpGoods = helpGoodsService.getById(cmccPointRecordVO.getHelpGoodsId());
		if (ObjectUtil.isNotEmpty(helpGoods)){
			cmccPointRecordVO.setHelpGoodsName(helpGoods.getName());
		}

		LoginUser loginUser = loginUserService.getById(cmccPointRecordVO.getUserId());
		if (ObjectUtil.isNotEmpty(loginUser)){
			cmccPointRecordVO.setUserName(loginUser.getNickName());
		}

		ActiveRecord activeRecord = activeRecordService.getById(cmccPointRecordVO.getActiveId());
		if(ObjectUtil.isNotEmpty(activeRecord)){
			cmccPointRecordVO.setActiveName(activeRecord.getTitle());
		}

		ActiveProductRecord activeProductRecord = activeProductRecordService.getById(cmccPointRecordVO.getActiveProductId());
		if(ObjectUtil.isNotEmpty(activeProductRecord)){
			cmccPointRecordVO.setActiveName(activeProductRecord.getTitle());
		}

		//User createUser = UserCache.getUser(cmccPointRecord.getCreateUser());
		//User updateUser = UserCache.getUser(cmccPointRecord.getUpdateUser());
		//cmccPointRecordVO.setCreateUserName(createUser.getName());
		//cmccPointRecordVO.setUpdateUserName(updateUser.getName());

		return cmccPointRecordVO;
	}

}
